"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GalileoIdeMetricsDashboardWidgetContribution = exports.GalileoIdeMetricsDashboardWidgetCommand = void 0;
var inversify_1 = require("inversify");
var galileo_ide_metrics_dashboard_widget_widget_1 = require("./galileo-ide-metrics-dashboard-widget-widget");
var browser_1 = require("@theia/core/lib/browser");
var frontend_application_state_1 = require("@theia/core/lib/browser/frontend-application-state");
exports.GalileoIdeMetricsDashboardWidgetCommand = {
    id: "galileo-ide-metrics-dashboard-widget:command",
};
var GalileoIdeMetricsDashboardWidgetContribution = /** @class */ (function (_super) {
    __extends(GalileoIdeMetricsDashboardWidgetContribution, _super);
    /**
     * `AbstractViewContribution` handles the creation and registering
     *  of the widget including commands, menus, and keybindings.
     *
     * We can pass `defaultWidgetOptions` which define widget properties such as
     * its location `area` (`main`, `left`, `right`, `bottom`), `mode`, and `ref`.
     *
     */
    function GalileoIdeMetricsDashboardWidgetContribution() {
        return _super.call(this, {
            widgetId: galileo_ide_metrics_dashboard_widget_widget_1.GalileoIdeMetricsDashboardWidgetWidget.ID,
            widgetName: galileo_ide_metrics_dashboard_widget_widget_1.GalileoIdeMetricsDashboardWidgetWidget.LABEL,
            defaultWidgetOptions: { area: "main" },
            toggleCommandId: exports.GalileoIdeMetricsDashboardWidgetCommand.id,
        }) || this;
    }
    GalileoIdeMetricsDashboardWidgetContribution.prototype.onStart = function (app) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.stateService.reachedState("ready").then(function () {
                    _this.openView({ reveal: false });
                });
                return [2 /*return*/];
            });
        });
    };
    /**
       * Example command registration to open the widget from the menu, and quick-open.
       * For a simpler use case, it is possible to simply call:
       ```ts
          super.registerCommands(commands)
       ```
       *
       * For more flexibility, we can pass `OpenViewArguments` which define
       * options on how to handle opening the widget:
       *
       ```ts
          toggle?: boolean
          activate?: boolean;
          reveal?: boolean;
       ```
       *
       * @param commands
       */
    GalileoIdeMetricsDashboardWidgetContribution.prototype.registerCommands = function (commands) {
        var _this = this;
        commands.registerCommand(exports.GalileoIdeMetricsDashboardWidgetCommand, {
            execute: function () { return _super.prototype.openView.call(_this, { reveal: true }); },
        });
    };
    /**
       * Example menu registration to contribute a menu item used to open the widget.
       * Default location when extending the `AbstractViewContribution` is the `View` main-menu item.
       *
       * We can however define new menu path locations in the following way:
       ```ts
          menus.registerMenuAction(CommonMenus.HELP, {
              commandId: 'id',
              label: 'label'
          });
       ```
       *
       * @param menus
       */
    GalileoIdeMetricsDashboardWidgetContribution.prototype.registerMenus = function (menus) {
        _super.prototype.registerMenus.call(this, menus);
    };
    __decorate([
        inversify_1.inject(frontend_application_state_1.FrontendApplicationStateService),
        __metadata("design:type", frontend_application_state_1.FrontendApplicationStateService)
    ], GalileoIdeMetricsDashboardWidgetContribution.prototype, "stateService", void 0);
    GalileoIdeMetricsDashboardWidgetContribution = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [])
    ], GalileoIdeMetricsDashboardWidgetContribution);
    return GalileoIdeMetricsDashboardWidgetContribution;
}(browser_1.AbstractViewContribution));
exports.GalileoIdeMetricsDashboardWidgetContribution = GalileoIdeMetricsDashboardWidgetContribution;
//# sourceMappingURL=galileo-ide-metrics-dashboard-widget-contribution.js.map