"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_jss_1 = require("react-jss");
var useStyles = react_jss_1.createUseStyles({
    container: {
        display: "grid",
        gridTemplateColumns: "repeat(auto-fill, 302px)",
        gridGap: 24,
        marginBottom: 36,
    },
    subTitle: {
        color: "var(--theia-descriptionForeground)",
        fontSize: 24,
        margin: "0 0 24px 0",
    },
});
var SingleValueContainer = function (props) {
    var widget = props.widget, children = props.children;
    var classes = useStyles();
    return (React.createElement(React.Fragment, null,
        React.createElement("h3", { className: classes.subTitle }, widget.title),
        React.createElement("div", { className: classes.container }, children)));
};
exports.default = SingleValueContainer;
//# sourceMappingURL=SingleValueContainer.js.map