import { ContainerModule } from "inversify";
import { PreferenceProxy, PreferenceSchema, PreferenceService } from "@theia/core/lib/browser";
import "../../src/browser/style/index.css";
import { EResponseFormat, IMetricWidget } from "./constants";
export declare const enum GALILEO_METRICS {
    TITLE = "galileo.metrics.title",
    METRIC_URL = "galileo.metrics.metric_url",
    RESPONSE_FORMAT = "galileo.metrics.response_format",
    WIDGETS = "galileo.metrics.widgets"
}
export declare const galileoMetricsWidgetConfigurationSchema: PreferenceSchema;
export interface galileoMetricsWidgetConfiguration {
    "galileo.metrics.title": string;
    "galileo.metrics.metric_url": string;
    "galileo.metrics.response_format": EResponseFormat;
    "galileo.metrics.widgets": IMetricWidget[];
}
export declare const GalileoMetricsWidgetPreferences: unique symbol;
export declare type GalileoMetricsWidgetPreferences = PreferenceProxy<galileoMetricsWidgetConfiguration>;
export declare function createGalileoMetricsWidgetPreferences(preferences: PreferenceService): GalileoMetricsWidgetPreferences;
declare const _default: ContainerModule;
export default _default;
//# sourceMappingURL=galileo-ide-metrics-dashboard-widget-frontend-module.d.ts.map