import * as React from "react";
import { ReactWidget } from "@theia/core/lib/browser/widgets/react-widget";
import { MessageService } from "@theia/core";
import { EResponseFormat, IMetricWidget } from "./constants";
import { PreferenceService } from "@theia/core/lib/browser";
export interface Settings {
    title: string;
    metricUrl: string;
    responseFormat: EResponseFormat;
    widgets: IMetricWidget[];
}
export declare class GalileoIdeMetricsDashboardWidgetWidget extends ReactWidget {
    static readonly ID = "galileo-ide-metrics-dashboard-widget:widget";
    static readonly LABEL = "Metrics Dashboard";
    protected readonly messageService: MessageService;
    protected readonly preferenceService: PreferenceService;
    protected _settings: Settings;
    protected init(): Promise<void>;
    protected loadSettings(): Promise<Settings>;
    protected render(): React.ReactNode;
}
//# sourceMappingURL=galileo-ide-metrics-dashboard-widget-widget.d.ts.map